<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Magnetic Unit Converter</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="magconv">Magnetic Unit Converter </a></h1><p>DISCLAIMER/GPL TERMS AND CONDITIONS: see <a class="el" href="gpl.html">GNU General Public License</a></p>
<h2><a class="anchor" id="vec3">
Vectors/Coordinates</a></h2>
 

<script type="text/javascript">
<!--

function vecconvert() {
  var x,y,z,xn,yn,zn,theta_rad,phi_rad,theta_deg,phi_deg,r;

  x     = 1*document.FormVecConvert.x.value;
  y     = 1*document.FormVecConvert.y.value;
  z     = 1*document.FormVecConvert.z.value;
  xn    = 1*document.FormVecConvert.xn.value;
  yn    = 1*document.FormVecConvert.yn.value;
  zn    = 1*document.FormVecConvert.zn.value;
  r     = 1*document.FormVecConvert.r.value;
  theta_rad = 1*document.FormVecConvert.theta_rad.value;
  phi_rad   = 1*document.FormVecConvert.phi_rad.value;
  theta_deg = 1*document.FormVecConvert.theta_deg.value;
  phi_deg   = 1*document.FormVecConvert.phi_deg.value;


  if (x != 0 || y != 0 || z != 0) {
    r=Math.sqrt(x*x+y*y+z*z);
    xn=x/r;
    yn=y/r;
    zn=z/r;
    theta_rad=Math.atan(Math.sqrt(x*x+y*y)/z);
    phi_rad=Math.atan(y/x);
  }
  else
  if (r != 0 ) {
    if (theta_deg != 0 || phi_deg != 0) {
      theta_rad=theta_deg/180.0*Math.PI;
      phi_rad=phi_deg/180.0*Math.PI;
    }
    else
    if (xn != 0 || yn != 0 || zn != 0) {
      theta_rad=Math.atan(Math.sqrt(xn*xn+yn*yn)/zn);
      phi_rad=Math.atan(yn/xn);
    }
    x=r*Math.sin(theta_rad)*Math.cos(phi_rad);
    y=r*Math.sin(theta_rad)*Math.sin(phi_rad);
    z=r*Math.cos(theta_rad);
    xn=x/r;
    yn=y/r;
    zn=z/r;
  }

  theta_deg=theta_rad*180.0/Math.PI;
  phi_deg=phi_rad*180.0/Math.PI;
  eff=Math.pow(Math.pow(x*x+y*y,1/3)+Math.pow(z,2/3),1.5);

  document.FormVecConvert.x.value     = x;
  document.FormVecConvert.y.value     = y;
  document.FormVecConvert.z.value     = z;
  document.FormVecConvert.xn.value    = xn;
  document.FormVecConvert.yn.value    = yn;
  document.FormVecConvert.zn.value    = zn;
  document.FormVecConvert.theta_rad.value = theta_rad;
  document.FormVecConvert.phi_rad.value   = phi_rad;
  document.FormVecConvert.theta_deg.value = theta_deg;
  document.FormVecConvert.phi_deg.value   = phi_deg;
  document.FormVecConvert.r.value     = r;
  document.FormVecConvert.eff.value   = eff;
}

function clearvecconv() {
  document.FormVecConvert.x.value     = 0;
  document.FormVecConvert.y.value     = 0;
  document.FormVecConvert.z.value     = 0;
  document.FormVecConvert.xn.value    = 0;
  document.FormVecConvert.yn.value    = 0;
  document.FormVecConvert.zn.value    = 0;
  document.FormVecConvert.theta_rad.value = 0;
  document.FormVecConvert.phi_rad.value   = 0;
  document.FormVecConvert.theta_deg.value = 0;
  document.FormVecConvert.phi_deg.value   = 0;
  document.FormVecConvert.r.value     = 0;
  document.FormVecConvert.eff.value   = 0;
}

-->

</script>

<form name="FormVecConvert" action="">
  <table border="0" bgcolor="#33ccff">
     <tbody>
       <tr>
         <td><input type="button" value=" Clear all " onclick="clearvecconv()"></td>
       </tr>
       <tr align="right">
         <td><strong>Cartesian</strong></td>
         <td></td>
         <td><strong>normalized</strong></td>
         <td></td>
       </tr>
       <tr align="right">
         <td>x</td>
         <td><input type="text" name="x" size="24"></td>
         <td>x/r</td>
         <td><input type="text" name="xn" size="24"></td>
       </tr>
       <tr align="right">
         <td>y</td>
         <td><input type="text" name="y" size="24"></td>
         <td>y/r</td>
         <td><input type="text" name="yn" size="24"></td>
       </tr>
       <tr align="right">
         <td>z</td>
         <td><input type="text" name="z" size="24"></td>
         <td>z/r</td>
         <td><input type="text" name="zn" size="24"></td>
       </tr>
       <tr align="right">
         <td><strong>spherical</strong></td>
         <td></td>
       </tr>
       <tr align="right">
         <td>r</td>
         <td><input type="text" name="r" size="24"></td>
       </tr>
       <tr align="right">
         <td>theta (rad)</td>
         <td><input type="text" name="theta_rad" size="24"></td>
         <td>theta (deg)</td>
         <td><input type="text" name="theta_deg" size="24"></td>
       </tr>
       <tr align="right">
         <td>phi (rad)</td>
         <td><input type="text" name="phi_rad" size="24"></td>
         <td>phi (deg)</td>
         <td><input type="text" name="phi_deg" size="24"></td>
       </tr>
       <tr align="right">
         <td><strong>extra</strong></td>
         <td></td>
       </tr>
       <tr align="right">
         <td>eff</td>
         <td>((x<sup>2</sup>+y<sup>2</sup>)<sup>(1/3)</sup>+z<sup>(2/3)</sup>)<sup>(3/2)</sup></td>
         <td>=</td>
         <td><input type="text" name="eff" size="24"></td>
       </tr>

       <tr>
         <td><input type="button" value=" Convert " onclick="vecconvert()"></td>
       </tr>
    </tbody>

  </table>
</form>

<h2><a class="anchor" id="field">
Magnetic field</a></h2>
 

<script type="text/javascript">
<!--

function fieldconvert() {
  var mu0;
  mu0 = 4*Math.PI*1e-7;

  var Tesla, Gauss, A_m, Oe, emu_ccm;

  Tesla   = 1*document.FormFieldConvert.Tesla.value;
  Gauss   = 1*document.FormFieldConvert.Gauss.value;
  A_m     = 1*document.FormFieldConvert.A_m.value;
  Oe      = 1*document.FormFieldConvert.Oe.value;
  emu_ccm = 1*document.FormFieldConvert.emu_ccm.value;

  if (Gauss != 0) {
    Tesla = Gauss*1e-4;
  }
  else
  if (A_m != 0) {
    Tesla = A_m*mu0;
  }
  else
  if (Oe != 0) {
    Tesla = Oe*1e-4;
  }
  if (emu_ccm != 0) {
    Tesla = emu_ccm*1e3*mu0;
  }

  A_m     = Tesla/mu0;
  Gauss   = Tesla/1e-4;
  Oe      = Tesla/1e-4;
  emu_ccm = Tesla/1e3/mu0;

  document.FormFieldConvert.Tesla.value   =  Tesla;
  document.FormFieldConvert.Gauss.value   =  Gauss;
  document.FormFieldConvert.A_m.value     =  A_m;
  document.FormFieldConvert.Oe.value      =  Oe;
  document.FormFieldConvert.emu_ccm.value =  emu_ccm;
}

function clearfieldconv() {
  document.FormFieldConvert.Tesla.value   =  0;
  document.FormFieldConvert.Gauss.value   =  0;
  document.FormFieldConvert.A_m.value     =  0;
  document.FormFieldConvert.Oe.value      =  0;
  document.FormFieldConvert.emu_ccm.value =  0;
}

-->

</script>

<form name="FormFieldConvert" action="">
  <table border="0" bgcolor="#33ccff">
     <tbody>
       <tr>
         <td><input type="button" value=" Clear all " onclick="clearfieldconv()"></td>
       </tr>
       <tr>
         <td><input type="text" name="Tesla" size="24"></td>
         <td>Tesla (flux density/induction)</td>
       </tr>
       <tr>
         <td><input type="text" name="Gauss" size="24"></td>
         <td>Gauss (flux density/induction)</td>
       </tr>
       <tr>
         <td><input type="text" name="A_m" size="24"></td>
         <td>A/m (magnetization/field)</td>
       </tr>
       <tr>
         <td><input type="text" name="Oe" size="24"></td>
         <td>Oe (field)</td>
       </tr>
       <tr>
         <td><input type="text" name="emu_ccm" size="24"></td>
         <td>emu/cm<sup>3</sup> (magnetization)</td>
       </tr>
       <tr>
         <td><input type="button" value=" Convert " onclick="fieldconvert()"></td>
       </tr>
    </tbody>

  </table>
</form>

<h2><a class="anchor" id="matprop">
Material properties</a></h2>
 

<script type="text/javascript">
<!--

function matprop() {
  var Pi;
  Pi = Math.PI;

  var K1, Js, A, Bext, vol, temp;

  K1      = 1*document.FormMatProp.K1.value;
  Js      = 1*document.FormMatProp.Js.value;
  A       = 1*document.FormMatProp.A.value;
  Bext    = 1*document.FormMatProp.Bext.value;
  vol     = 1*document.FormMatProp.vol.value;
  temp    = 1*document.FormMatProp.temp.value;

  var Hani, Bani, lexch1, lexch2, lBloch, EBloch;
  var f_Larmor_ani, f_Larmor_dem, f_Larmor_ext;
  var T_Larmor_ani, T_Larmor_dem, T_Larmor_ext;
  var kvkbt;

  var mu0;
  mu0 = 4*Math.PI*1e-7;

  Hani   = 2*K1/Js;
  Bani   = 2*K1/Js*mu0;
  lexch1 = Math.sqrt(2*mu0*A/(Js*Js))*1e9;
  lexch2 = Math.sqrt(A/K1)*1e9;
  lBloch = Math.PI*Math.sqrt(A/K1)*1e9;
  EBloch = 4.0*Math.sqrt(A*K1);

  var GAMMA;
  GAMMA = 2.210173e5;

  f_Larmor_ani = GAMMA*2.0*K1/Js/(2.0*Math.PI)/1e9;
  f_Larmor_dem = GAMMA*Js/mu0/(2.0*Math.PI)/1e9;
  f_Larmor_ext = GAMMA/mu0*Bext/(2.0*Math.PI)/1e9;

  T_Larmor_ani = 1/(GAMMA*2.0*K1/Js/(2.0*Math.PI))*1e9;
  T_Larmor_dem = 1/(GAMMA*Js/mu0/(2.0*Math.PI))*1e9;
  T_Larmor_ext = 1/(GAMMA/mu0*Bext/(2.0*Math.PI))*1e9;

  kvkbt = K1*vol*1e-27/(1.380658e-23*temp);

  document.FormMatProp.Hani.value         = Hani;
  document.FormMatProp.Bani.value         = Bani;
  document.FormMatProp.lexch1.value       = lexch1;
  document.FormMatProp.lexch2.value       = lexch2;
  document.FormMatProp.lBloch.value       = lBloch;
  document.FormMatProp.EBloch.value       = EBloch;
  document.FormMatProp.f_Larmor_ani.value = f_Larmor_ani;
  document.FormMatProp.f_Larmor_dem.value = f_Larmor_dem;
  document.FormMatProp.f_Larmor_ext.value = f_Larmor_ext;
  document.FormMatProp.T_Larmor_ani.value = T_Larmor_ani;
  document.FormMatProp.T_Larmor_dem.value = T_Larmor_dem;
  document.FormMatProp.T_Larmor_ext.value = T_Larmor_ext;
  document.FormMatProp.kvkbt.value = kvkbt;
}

function clearmatprop() {
  document.FormMatProp.K1.value   =  0;
  document.FormMatProp.Js.value   =  0;
  document.FormMatProp.A.value    =  0;
  document.FormMatProp.Bext.value =  0;

  document.FormMatProp.Hani.value         =  0;
  document.FormMatProp.Bani.value         =  0;
  document.FormMatProp.lexch1.value       =  0;
  document.FormMatProp.lexch2.value       =  0;
  document.FormMatProp.lBloch.value       =  0;
  document.FormMatProp.EBloch.value       =  0;
  document.FormMatProp.f_Larmor_ani.value =  0;
  document.FormMatProp.f_Larmor_dem.value =  0;
  document.FormMatProp.f_Larmor_ext.value =  0;
  document.FormMatProp.T_Larmor_ani.value =  0;
  document.FormMatProp.T_Larmor_dem.value =  0;
  document.FormMatProp.T_Larmor_ext.value =  0;
  document.FormMatProp.kvkbt =  0;
}

-->

</script>

<form name="FormMatProp" action="">
  <table border="0" bgcolor="#33ccff">
     <tbody>
       <tr>
         <td><input type="button" value=" Clear all " onclick="clearmatprop()"></td>
       </tr>
       <tr>
         <td>magnetocrystalline anisotropy constant <i>K</i><sub>1</sub></td>
         <td><input type="text" name="K1" size="24"></td>
         <td>J/m<sup>3</sup></td>
       </tr>
       <tr>
         <td>saturation polarization <i>J</i><sub>s</sub></td>
         <td><input type="text" name="Js" size="24"></td>
         <td>T</td>
       </tr>
       <tr>
         <td>exchange constant <i>A</i></td>
         <td><input type="text" name="A" size="24"></td>
         <td>J/m</td>
       </tr>
       <tr>
         <td>external field <i>B</i><sub>ext</sub></td>
         <td><input type="text" name="Bext" size="24"></td>
         <td>T</td>
       </tr>
       <tr>
         <td>volume <i>V</i></td>
         <td><input type="text" name="vol" size="24"></td>
         <td>nm<sup>3</sup></td>
       </tr>
       <tr>
         <td>temperature <i>T</i></td>
         <td><input type="text" name="temp" size="24"></td>
         <td>K</td>
       </tr>
       <tr>
         <td><input type="button" value=" Calculate " onclick="matprop()"></td>
       </tr>
       <tr>
         <td>anisotropy field <i>H</i><sub>ani</sub>=2 <i>K</i><sub>1</sub>/<i>J</i><sub>s</sub></td>
         <td><input type="text" name="Hani" size="24"></td>
         <td>A/m</td>
       </tr>
       <tr>
         <td></td>
         <td><input type="text" name="Bani" size="24"></td>
         <td>T</td>
       </tr>
       <tr>
         <td>exchange length 1: <i>l</i><sub>exch1</sub>=sqrt(2*<i>&#956;</i><sub>0</sub> <i>A</i>/<i>J</i><sub>s</sub><sup>2</sup>)</td>
         <td><input type="text" name="lexch1" size="24"></td>
         <td>nm</td>
       </tr>
       <tr>
         <td>exchange length 2: <i>l</i><sub>exch2</sub>=sqrt(<i>A</i>/<i>K</i><sub>1</sub>)</td>
         <td><input type="text" name="lexch2" size="24"></td>
         <td>nm</td>
       </tr>
       <tr>
         <td>Bloch wall width: <i>d</i><sub>Bloch</sub>=&#960; sqrt(<i>A</i>/<i>K</i><sub>1</sub>)</td>
         <td><input type="text" name="lBloch" size="24"></td>
         <td>nm</td>
       </tr>
       <tr>
         <td>Bloch wall energy: <i>E</i><sub>Bloch</sub>=4 sqrt(<i>A</i> <i>K</i><sub>1</sub>)</td>
         <td><input type="text" name="EBloch" size="24"></td>
         <td>J/m<sup>2</sup></td>
       </tr>
       <tr>
         <td>Larmor frequency (anisotropy field)</td>
         <td><input type="text" name="f_Larmor_ani" size="24"></td>
         <td>GHz</td>
       </tr>
       <tr>
         <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;precession period</td>
         <td><input type="text" name="T_Larmor_ani" size="24"></td>
         <td>ns</td>
       </tr>
       <tr>
         <td>Larmor frequency (demag. field:=<i>J</i><sub>s</sub>)</td>
         <td><input type="text" name="f_Larmor_dem" size="24"></td>
         <td>GHz</td>
       </tr>
       <tr>
         <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;precession period</td>
         <td><input type="text" name="T_Larmor_dem" size="24"></td>
         <td>ns</td>
       </tr>
       <tr>
         <td>Larmor frequency (external field)</td>
         <td><input type="text" name="f_Larmor_ext" size="24"></td>
         <td>GHz</td>
       </tr>
       <tr>
         <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;precession period</td>
         <td><input type="text" name="T_Larmor_ext" size="24"></td>
         <td>ns</td>
       </tr>
       <tr>
         <td>thermal stability <i>K</i><sub>1</sub><i>V</i>/(<i>k</i><sub>B</sub> <i>T</i>)</td>
         <td><input type="text" name="kvkbt" size="24"></td>
         <td></td>
       </tr>
    </tbody>
  </table>
</form>

<p>JavaScript code adapted from Rok Dittrich's <a class="el" href="demagcalc.html">Calculator for magnetostatic energy and demagnetizing factor</a> with Rok's permission. </p>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

